## ros-noetic-graceful-controller-ros 0.4.6

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(graceful_controller_ros)

if (CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
endif()

find_package(catkin REQUIRED
  COMPONENTS
    angles
    base_local_planner
    costmap_2d
    dynamic_reconfigure
    geometry_msgs
    graceful_controller
    nav_msgs
    pluginlib
    roscpp
    std_msgs
    tf2_geometry_msgs
    tf2_ros
)

generate_dynamic_reconfigure_options(
    cfg/GracefulController.cfg
)

catkin_package(
  INCLUDE_DIRS
    include
  CATKIN_DEPENDS
    base_local_planner
    costmap_2d
    dynamic_reconfigure
    geometry_msgs
    graceful_controller
    nav_msgs
    pluginlib
    roscpp
    std_msgs
    tf2_geometry_msgs
    tf2_ros
  LIBRARIES
    graceful_controller_ros
)

if (CATKIN_ENABLE_TESTING AND ENABLE_COVERAGE_TESTING)
  find_package(code_coverage REQUIRED)
  APPEND_COVERAGE_COMPILER_FLAGS()
endif()

include_directories(
  include
  ${catkin_INCLUDE_DIRS}
)

add_library(graceful_controller_ros
  src/graceful_controller_ros.cpp
  src/orientation_tools.cpp
  src/visualization.cpp
)
target_link_libraries(graceful_controller_ros
  ${catkin_LIBRARIES}
)
add_dependencies(graceful_controller_ros
  ${${PROJECT_NAME}_EXPORTED_TARGETS}
  ${catkin_EXPORTED_TARGETS}
)

if(CATKIN_ENABLE_TESTING)
  find_package(rostest)

  add_executable(graceful_controller_tests
    test/graceful_controller_tests.cpp
  )
  target_link_libraries(graceful_controller_tests
    ${catkin_LIBRARIES}
    ${GTEST_LIBRARIES}
    graceful_controller_ros
  )
  add_dependencies(tests graceful_controller_tests)
  add_rostest(test/graceful_controller.test)

  catkin_add_gtest(orientation_filter_tests
    src/orientation_tools.cpp
    test/orientation_tools_tests.cpp
  )
  target_link_libraries(orientation_filter_tests
    ${catkin_LIBRARIES}
  )

  if(ENABLE_COVERAGE_TESTING)
    set(COVERAGE_EXCLUDES "*/${PROJECT_NAME}/test*")
    add_code_coverage(
      NAME ${PROJECT_NAME}_coverage_report
      DEPENDS tests
    )
  endif()
endif()

install(TARGETS graceful_controller_ros
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
)

install(FILES plugins.xml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

=== debian/changelog ===
ros-noetic-graceful-controller-ros (0.4.6-1buster) buster; urgency=high

  * follow acceleration limits when velocity limit changes (#62 <https://github.com/mikeferguson/graceful_controller/issues/62>)
  * add angular velocity limiting control (#61 <https://github.com/mikeferguson/graceful_controller/issues/61>)
    Adds max_x_to_max_theta_scale_factor which can be used to control how the angular velocity changes relative to the linear velocity when use_vel_topic feature is enabled.
  * Contributors: Michael Ferguson, TrazCobalt

 -- Michael Ferguson <mfergs7@gmail.com>  Mon, 20 Feb 2023 08:00:00 -0000

ros-noetic-graceful-controller-ros (0.4.5-1buster) buster; urgency=high

  * compute lookahead as distance along path (#55 <https://github.com/mikeferguson/graceful_controller/issues/55>)
  * Contributors: Michael Ferguson

 -- Michael Ferguson <mfergs7@gmail.com>  Wed, 24 Aug 2022 07:00:00 -0000

ros-noetic-graceful-controller-ros (0.4.4-1buster) buster; urgency=high

  * always rotate to match desired heading (#54 <https://github.com/mikeferguson/graceful_controller/issues/54>)
    If the goal tolerances are large (greater than 0.5m) the
    robot might end up trying to point at the goal rather than
    aligning with the goal heading
  * Contributors: Michael Ferguson

 -- Michael Ferguson <mfergs7@gmail.com>  Wed, 24 Aug 2022 07:00:00 -0000

ros-noetic-graceful-controller-ros (0.4.3-1buster) buster; urgency=high

  * use separate decel_lim_x for control law (#45 <https://github.com/mikeferguson/graceful_controller/issues/45>)
  * add velocity limit to goal tolerance (#44 <https://github.com/mikeferguson/graceful_controller/issues/44>)
  * fix deceleration time (#43 <https://github.com/mikeferguson/graceful_controller/issues/43>)
    this reverts #6 <https://github.com/mikeferguson/graceful_controller/issues/6>, to what is apparently the correct math
  * add footprint inflation for higher speeds (#32 <https://github.com/mikeferguson/graceful_controller/issues/32>)
    * add a feature to inflate the footprint at higher speeds
    * only update max_vel_x once per call
  * initialze collision_points_ to null (#35 <https://github.com/mikeferguson/graceful_controller/issues/35>)
  * add optional visualization of colliding points (#34 <https://github.com/mikeferguson/graceful_controller/issues/34>)
  * split out hpp file, clang format (#33 <https://github.com/mikeferguson/graceful_controller/issues/33>)
  * fix bug in latch_xy_goal_tolerance (#31 <https://github.com/mikeferguson/graceful_controller/issues/31>)
    While the main control loop can latch the goal (thus it will stop trying to hunt around) - that isn't understood by the isGoalReached() function - which leads to the robot wiggling back and forth for a while
  * Contributors: Michael Ferguson

 -- Michael Ferguson <mfergs7@gmail.com>  Sat, 18 Jun 2022 07:00:00 -0000

ros-noetic-graceful-controller-ros (0.4.2-1buster) buster; urgency=high

  * fix goal tolerance reset (#29 <https://github.com/mikeferguson/graceful_controller/issues/29>)
  * add latch_xy_goal_tolerance parameter (#28 <https://github.com/mikeferguson/graceful_controller/issues/28>)
  * fix orientation issue with collision checking (#27 <https://github.com/mikeferguson/graceful_controller/issues/27>)
  * Contributors: Michael Ferguson

 -- Michael Ferguson <mfergs7@gmail.com>  Tue, 29 Mar 2022 07:00:00 -0000

ros-noetic-graceful-controller-ros (0.4.1-1buster) buster; urgency=high

  * add ability to disable orientation filtering (#26 <https://github.com/mikeferguson/graceful_controller/issues/26>)
    also make everything dynamic reconfigurable
  * don't crash when path is empty (#25 <https://github.com/mikeferguson/graceful_controller/issues/25>)
  * add min_lookahead parameter (#24 <https://github.com/mikeferguson/graceful_controller/issues/24>)
    when the pose is very close to the robot, we can get
    some instability (rapid side-to-side movement due to
    large angular errors over small linear distances). by
    adding this parameter, we can instead fallback to
    recovery behaviors and find a better path.
  * fix occasional boost::lock crash (#23 <https://github.com/mikeferguson/graceful_controller/issues/23>)
  * limit the distance between poses as filter runs (#21 <https://github.com/mikeferguson/graceful_controller/issues/21>)
  * improve the orientation filter, add tests (#20 <https://github.com/mikeferguson/graceful_controller/issues/20>)
  * Contributors: Michael Ferguson

 -- Michael Ferguson <mfergs7@gmail.com>  Fri, 11 Mar 2022 08:00:00 -0000

ros-noetic-graceful-controller-ros (0.4.0-1buster) buster; urgency=high

  * add usage documentation (#19 <https://github.com/mikeferguson/graceful_controller/issues/19>)
    also remove unused min_vel_theta parameter
  * implement changes from review (#18 <https://github.com/mikeferguson/graceful_controller/issues/18>)
    * Add collision checking during final rotation
    * Add comments about getRobotVel returning velocities
    * Rename path to simulated_path for clarity
    * Rename pose to target_pose and goal_pose (now separate variables)
    * Get rid of magic number for when to use final rotation
  * simulate intial rotation properly (#17 <https://github.com/mikeferguson/graceful_controller/issues/17>)
    previously, this simulated the big arc that we wouldn't follow anyways.
    this could cause the robot to get stuck in corners or other tight areas.
  * Contributors: Michael Ferguson

 -- Michael Ferguson <mfergs7@gmail.com>  Mon, 14 Jun 2021 07:00:00 -0000

ros-noetic-graceful-controller-ros (0.3.1-1buster) buster; urgency=high

  * add feature for final rotation (#15 <https://github.com/mikeferguson/graceful_controller/issues/15>)
    if the final pose orientation is very different from the end
    of the path, we get a big sweeping turn. this feature uses
    the previous orientation to avoid that sweeping turn and
    instead does a final in-place rotation. Add filter and pose
    publisher.


=== debian/control ===
Source: ros-noetic-graceful-controller-ros
Section: misc
Priority: optional
Maintainer: Michael Ferguson <mfergs7@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-noetic-angles, ros-noetic-base-local-planner, ros-noetic-catkin, ros-noetic-costmap-2d, ros-noetic-dynamic-reconfigure, ros-noetic-geometry-msgs, ros-noetic-graceful-controller, ros-noetic-nav-core, ros-noetic-nav-msgs, ros-noetic-pluginlib, ros-noetic-roscpp, ros-noetic-std-msgs, ros-noetic-tf2-geometry-msgs, ros-noetic-tf2-ros
Homepage: 
Standards-Version: 3.9.2

Package: ros-noetic-graceful-controller-ros
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-noetic-angles, ros-noetic-base-local-planner, ros-noetic-costmap-2d, ros-noetic-dynamic-reconfigure, ros-noetic-geometry-msgs, ros-noetic-graceful-controller, ros-noetic-nav-core, ros-noetic-nav-msgs, ros-noetic-pluginlib, ros-noetic-roscpp, ros-noetic-std-msgs, ros-noetic-tf2-geometry-msgs, ros-noetic-tf2-ros
Description: A controller.
 Some say it might be graceful.

## ros-noetic-graceful-controller-ros 0.4.8

=== debian/changelog ===
ros-noetic-graceful-controller-ros (0.4.8-1focal) focal; urgency=high

  * fix stutter when robot velocity exceeds max_vel_x (#69 <https://github.com/mikeferguson/graceful_controller/issues/69>)
    a bit of noise on the odometry can cause the robot to overshoot
    the max_vel_x - this would then cause us to decelerate - possibly
    quite hard if the decel_lim_x was high.
  * Contributors: Michael Ferguson

 -- Michael Ferguson <mfergs7@gmail.com>  Mon, 06 Mar 2023 05:00:00 -0000

ros-noetic-graceful-controller-ros (0.4.7-1focal) focal; urgency=high

  * generate linear movements if final in-place rotation is infeasible (#67 <https://github.com/mikeferguson/graceful_controller/issues/67>)
  * Contributors: Michael Ferguson

 -- Michael Ferguson <mfergs7@gmail.com>  Sun, 26 Feb 2023 05:00:00 -0000

ros-noetic-graceful-controller-ros (0.4.6-1focal) focal; urgency=high

  * follow acceleration limits when velocity limit changes (#62 <https://github.com/mikeferguson/graceful_controller/issues/62>)
  * add angular velocity limiting control (#61 <https://github.com/mikeferguson/graceful_controller/issues/61>)
    Adds max_x_to_max_theta_scale_factor which can be used to control how the angular velocity changes relative to the linear velocity when use_vel_topic feature is enabled.
  * Contributors: Michael Ferguson, TrazCobalt

 -- Michael Ferguson <mfergs7@gmail.com>  Mon, 20 Feb 2023 05:00:00 -0000

ros-noetic-graceful-controller-ros (0.4.5-1focal) focal; urgency=high

  * compute lookahead as distance along path (#55 <https://github.com/mikeferguson/graceful_controller/issues/55>)
  * Contributors: Michael Ferguson

 -- Michael Ferguson <mfergs7@gmail.com>  Wed, 24 Aug 2022 04:00:00 -0000

ros-noetic-graceful-controller-ros (0.4.4-1focal) focal; urgency=high

  * always rotate to match desired heading (#54 <https://github.com/mikeferguson/graceful_controller/issues/54>)
    If the goal tolerances are large (greater than 0.5m) the
    robot might end up trying to point at the goal rather than
    aligning with the goal heading
  * Contributors: Michael Ferguson

 -- Michael Ferguson <mfergs7@gmail.com>  Wed, 24 Aug 2022 04:00:00 -0000

ros-noetic-graceful-controller-ros (0.4.3-1focal) focal; urgency=high

  * use separate decel_lim_x for control law (#45 <https://github.com/mikeferguson/graceful_controller/issues/45>)
  * add velocity limit to goal tolerance (#44 <https://github.com/mikeferguson/graceful_controller/issues/44>)
  * fix deceleration time (#43 <https://github.com/mikeferguson/graceful_controller/issues/43>)
    this reverts #6 <https://github.com/mikeferguson/graceful_controller/issues/6>, to what is apparently the correct math
  * add footprint inflation for higher speeds (#32 <https://github.com/mikeferguson/graceful_controller/issues/32>)
    * add a feature to inflate the footprint at higher speeds
    * only update max_vel_x once per call
  * initialze collision_points_ to null (#35 <https://github.com/mikeferguson/graceful_controller/issues/35>)
  * add optional visualization of colliding points (#34 <https://github.com/mikeferguson/graceful_controller/issues/34>)
  * split out hpp file, clang format (#33 <https://github.com/mikeferguson/graceful_controller/issues/33>)
  * fix bug in latch_xy_goal_tolerance (#31 <https://github.com/mikeferguson/graceful_controller/issues/31>)
    While the main control loop can latch the goal (thus it will stop trying to hunt around) - that isn't understood by the isGoalReached() function - which leads to the robot wiggling back and forth for a while
  * Contributors: Michael Ferguson

 -- Michael Ferguson <mfergs7@gmail.com>  Sat, 18 Jun 2022 04:00:00 -0000

ros-noetic-graceful-controller-ros (0.4.2-1focal) focal; urgency=high

  * fix goal tolerance reset (#29 <https://github.com/mikeferguson/graceful_controller/issues/29>)
  * add latch_xy_goal_tolerance parameter (#28 <https://github.com/mikeferguson/graceful_controller/issues/28>)
  * fix orientation issue with collision checking (#27 <https://github.com/mikeferguson/graceful_controller/issues/27>)
  * Contributors: Michael Ferguson

 -- Michael Ferguson <mfergs7@gmail.com>  Tue, 29 Mar 2022 04:00:00 -0000

ros-noetic-graceful-controller-ros (0.4.1-1focal) focal; urgency=high

  * add ability to disable orientation filtering (#26 <https://github.com/mikeferguson/graceful_controller/issues/26>)
    also make everything dynamic reconfigurable
  * don't crash when path is empty (#25 <https://github.com/mikeferguson/graceful_controller/issues/25>)
  * add min_lookahead parameter (#24 <https://github.com/mikeferguson/graceful_controller/issues/24>)
    when the pose is very close to the robot, we can get
    some instability (rapid side-to-side movement due to
    large angular errors over small linear distances). by
    adding this parameter, we can instead fallback to
    recovery behaviors and find a better path.
  * fix occasional boost::lock crash (#23 <https://github.com/mikeferguson/graceful_controller/issues/23>)
  * limit the distance between poses as filter runs (#21 <https://github.com/mikeferguson/graceful_controller/issues/21>)
  * improve the orientation filter, add tests (#20 <https://github.com/mikeferguson/graceful_controller/issues/20>)
  * Contributors: Michael Ferguson

 -- Michael Ferguson <mfergs7@gmail.com>  Fri, 11 Mar 2022 05:00:00 -0000

ros-noetic-graceful-controller-ros (0.4.0-1focal) focal; urgency=high

  * add usage documentation (#19 <https://github.com/mikeferguson/graceful_controller/issues/19>)
    also remove unused min_vel_theta parameter
  * implement changes from review (#18 <https://github.com/mikeferguson/graceful_controller/issues/18>)
    * Add collision checking during final rotation
    * Add comments about getRobotVel returning velocities
    * Rename path to simulated_path for clarity
    * Rename pose to target_pose and goal_pose (now separate variables)
    * Get rid of magic number for when to use final rotation


=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-graceful-controller-ros//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
